/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.ScriptFileRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptFile extends TableImpl<ScriptFileRecord> {

	private static final long serialVersionUID = -707643171;

	/**
	 * The reference instance of <code>public.script_file</code>
	 */
	public static final ScriptFile SCRIPT_FILE = new ScriptFile();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<ScriptFileRecord> getRecordType() {
		return ScriptFileRecord.class;
	}

	/**
	 * The column <code>public.script_file.id</code>.
	 */
	public final TableField<ScriptFileRecord, Integer> ID = createField("id", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.script_file.name</code>.
	 */
	public final TableField<ScriptFileRecord, String> NAME = createField("name", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.script_file.version</code>.
	 */
	public final TableField<ScriptFileRecord, String> VERSION = createField("version", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.script_file.data</code>.
	 */
	public final TableField<ScriptFileRecord, byte[]> DATA = createField("data", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.script_file.check_sum</code>.
	 */
	public final TableField<ScriptFileRecord, Long> CHECK_SUM = createField("check_sum", org.jooq.impl.SQLDataType.BIGINT, this, "");

	/**
	 * The column <code>public.script_file.compilation_time</code>.
	 */
	public final TableField<ScriptFileRecord, Date> COMPILATION_TIME = createField("compilation_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.script_file.upload_time</code>.
	 */
	public final TableField<ScriptFileRecord, Date> UPLOAD_TIME = createField("upload_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.script_file.file_count</code>.
	 */
	public final TableField<ScriptFileRecord, Integer> FILE_COUNT = createField("file_count", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.script_file.class_count</code>.
	 */
	public final TableField<ScriptFileRecord, Integer> CLASS_COUNT = createField("class_count", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * Create a <code>public.script_file</code> table reference
	 */
	public ScriptFile() {
		this("script_file", null);
	}

	/**
	 * Create an aliased <code>public.script_file</code> table reference
	 */
	public ScriptFile(String alias) {
		this(alias, SCRIPT_FILE);
	}

	private ScriptFile(String alias, Table<ScriptFileRecord> aliased) {
		this(alias, aliased, null);
	}

	private ScriptFile(String alias, Table<ScriptFileRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<ScriptFileRecord, Integer> getIdentity() {
		return Keys.IDENTITY_SCRIPT_FILE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<ScriptFileRecord> getPrimaryKey() {
		return Keys.SCRIPT_FILE_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<ScriptFileRecord>> getKeys() {
		return Arrays.<UniqueKey<ScriptFileRecord>>asList(Keys.SCRIPT_FILE_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptFile as(String alias) {
		return new ScriptFile(alias, this);
	}

	/**
	 * Rename this table
	 */
	public ScriptFile rename(String name) {
		return new ScriptFile(name, null);
	}
}
